//+--------------------------------------------------------------------------+
//|                                                        MP MTF pj9100.mq4 |
//|                                                                          |
//|                                                                  http:// |
//+--------------------------------------------------------------------------+

//       MP MTF pj9100 v0.20.mq4
//6.sept.2009 - replace dll function with buil-in function (no need dll)
//            - remove max. number of selected symbols
//            - add sets of Symbols with color select and visible switch
//            - added symbolFontSize and change position of text on chart
//            - added visible switch for histogram (work with histoType=1)
//            - added visible switch for daily bars (work with histiType=1)
//                                     
//       MP MTF pj9100 v0.12.mq4
// 4.sept.2009 - barSpace - fixed this function for all Zoom chart levels!
//       MP MTF pj9100 v0.11.mq4                                             
// 4.sept.2009 - fixed daily hi-Lo calculated (num. of bars = shift +1)      
//             - add daily bar for each currency pair (OpCl, HiLo)                       
//             - change "barSpace" from absolute to relative space (0-1) 
//             - added "scaleText" option
//   
//       MP MTF pj9100 v0.10.mq4                                             
// 1.sept.2009  -fixed start of week for weeks with start in previous monath 



#property copyright "Rafaell & pj9100"
#property link      "http://"

//#property indicator_chart_window
#property indicator_separate_window
#property indicator_buffers 4


#property indicator_color1 C'40,43,43'
#property indicator_color2 C'40,43,43'
#property indicator_color3 Khaki
#property indicator_color4 Khaki

#property indicator_width1 5
#property indicator_width2 5
#property indicator_width3 5
#property indicator_width4 5


#property indicator_level1 0
#property indicator_levelstyle STYLE_DASHDOTDOT
#property indicator_levelcolor1 DarkSlateGray

#include <stderror.mqh>
#include <stdlib.mqh>




extern string  ISymbols1 = "EURUSD,EURGBP,EURCHF,EURJPY,EURAUD,EURNZD,EURCAD"; //currency pairs, separated with ','
extern bool    showSet1 = True;
extern color   setColor1 = Yellow;
extern string  ISymbols2 = "USDCHF,USDJPY,USDCAD";
extern bool    showSet2 = True;
extern color   setColor2 = Aqua;
extern string  ISymbols3 = "GBPUSD,GBPCHF,GBPJPY,GBPAUD,GBPCAD,GBPNZD";
extern bool    showSet3 = True;
extern color   setColor3 = Orange;
extern string  ISymbols4 = "GOLD,SILVER";
extern bool    showSet4 = False;
extern color   setColor4 = White;
extern string  ISymbols5 = "GBPJPY,USDJPY,CHFJPY,AUDCAD,AUDJPY,AUDNZD,CADJPY,NZDCAD,NZDCHF,NZDJPY,AUDCHF,CADCHF";
extern bool    showSet5 = True;
extern color   setColor5 = DarkGoldenrod;


extern bool    showDailyStat= True;    //showDailyStat=True - show daily statistics text in main window, showDailyStat=False - Off
extern bool    changeInPips = True;    //changeInPips = True - show change in Pips,  =False - show daily change in %
extern int     statMode=1;             //statMode = 0, show changes from current day time 00:00 + timeAdj, statMode = 1 - show changes for last 24hours
extern int     timeAdj=0;              //timeAdj has affect only if "statMode=0"
extern int     sideDS = 3;             //sideDS=0-3, show daily statistics in main window corner: 0-leftupper, 1-rightupper, 2-leftlowwer, 2- rightlowwer 

extern double     barsSpace = 0;       //barspace=any number between 0-1, (see picture)
extern bool    showMTStat = True;      //showMTStat = True - text data for periods "Tperiods1 - TPeriods6" will be shown, =False - Off (not show data..)
extern bool    showSmallTfText = True; //showSmallTfText=True - text data for periods last week, last monath, last 3 monath, last year, will be shown, =False - Off 
extern string  Tperiod1 = "2000.1.1";  //Tperiod1 = any date in format yyyy.mm.dd 
extern string  Tperiod2 = "2005.1.1";  //   -||-
extern string  Tperiod3 = "2007.1.1";  //   -||-
extern string  Tperiod4 = "2008.1.1";  //   -||-
extern string  Tperiod5 = "2009.1.1";  //   -||-
extern string  Tperiod6 = "2009.3.1 00:00";  //   -||-, Time has no effect (for calcualtion is used daily bar)
extern int     histoType = 1;          // histoType = 0 or 1 
extern bool    showHistogram = True;   // =True - On, =False - Off
extern bool    showDailyBar = True;    // =True - On, =False - Off  
extern int     fontSize=10;            //fontSize = any int nummber, size of fonts for displayed text
extern double  scaleText=1.0;          //scaleText = any nummber - scale for displayed text (include position and font size) displayed font size = fontSize*scaleText 
extern int     symbolFontSize=14;      //fontsize for symbol text on chart 
extern string  fontName = "";          //fontName = any avalible fonts supported on your computer


//extern string Tperiod5 = "D3";


int numFirstTf = 4;
int tfc[]={6, 7, 8, 9};
string tfsc[] = {"W", "Mo", "Q", "Y"};
string tfs[12];
int tf[12];
int tfFBar[][12];
datetime tfstart[][12];
int numTf = 12; 
int i,j,k,n,m;
int count;
int numSym;
int multb;
int space;
int lastBar;


int dataPeriod = PERIOD_H1;
int lDataBar=1;

bool checkForData=False;
double   current[],
         pcurrent[],
         dh[],
         dl[],
         dch[],
         dcl[],
         dco[],
         dcco[],
         dr[],
         dmco[][12],
         dHigh[][12],
         dLow[][12],
         dOpen[][12],
         adr[][6];
int   pBars[][12];
bool  avalDataTf[][12];
double toPoint[];
string ssym[];
string ssymShow[];
int   setOfSymbol[];
string ind;

int   xx=5,
      xx0;
int yy=5;
int whereDS=0;
int numPrObj;
int symTextSp1;
int symTextSp2;
int firstTf = 6;
double   dchMax,
         dclMax,
//         drMax,
         hiMax;
double   scaleDaBar,
         zeroLevelDaBar;

string   tmptext;
double tmp;         
//datetime pTime[];

//bool recaldata[];




color textCol=YellowGreen;
color dCol = Red;
color uCol = Lime;   
color nCol = Gold;

double mr[];
double mr1[];
double hi[];
double lo[];
double op[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   
   
   if (histoType == 0) {
      SetIndexBuffer(0, hi);
      SetIndexStyle(0 ,DRAW_HISTOGRAM,STYLE_SOLID, 5, C'40,43,43');
      SetIndexBuffer(1, lo);
      SetIndexStyle(1 ,DRAW_HISTOGRAM,STYLE_SOLID, 5, C'40,43,43');
      SetIndexBuffer(2, mr);
      SetIndexStyle(2 ,DRAW_HISTOGRAM,STYLE_SOLID, 5, Khaki);
      
      SetIndexLabel(0,"Distance to High");
      SetIndexLabel(1,"Distance to Low");
      SetIndexLabel(2,"Distance to Open");

   }
   else if (showHistogram == True) {
      SetIndexBuffer(0, hi);
      SetIndexStyle(0 ,DRAW_HISTOGRAM, STYLE_SOLID, 5, C'40,43,43');
      SetIndexBuffer(1, lo);
      SetIndexStyle(1 ,DRAW_HISTOGRAM, STYLE_SOLID, 5, Khaki);
      SetIndexBuffer(2, mr);
      SetIndexStyle(2 ,DRAW_HISTOGRAM, STYLE_SOLID, 5, Green);
      SetIndexBuffer(3, mr1);
      SetIndexStyle(3 ,DRAW_HISTOGRAM, STYLE_SOLID, 5, Red);
      
      SetIndexLabel(0,"High to Low");
      SetIndexLabel(1,"Average daily Range");
      SetIndexLabel(2,"Open to Close (+)");
      SetIndexLabel(3,"Open to Close (-)");
  }    
  else if (showDailyBar==True) {
      SetIndexBuffer(0, hi);
      SetIndexStyle(0 ,DRAW_HISTOGRAM, STYLE_SOLID, 5, DarkSlateGray);
      SetIndexBuffer(1, lo);
      SetIndexStyle(1 ,DRAW_HISTOGRAM, STYLE_SOLID, 5, DarkSlateGray);
      SetIndexBuffer(2, mr);
      SetIndexStyle(2 ,DRAW_HISTOGRAM, STYLE_SOLID, 5, Green);
      SetIndexBuffer(3, mr1);
      SetIndexStyle(3 ,DRAW_HISTOGRAM, STYLE_SOLID, 5, Red);
      
      SetIndexLabel(0,"From High");
      SetIndexLabel(1,"From Low");
      SetIndexLabel(2,"Open to Close (+)");
      SetIndexLabel(3,"Open to Close (-)");
   }   
      
  
   IndicatorDigits(0); 
   
   
   ind = WindowExpertName();
   IndicatorShortName(ind); 
   
 

   
   
   
   
   numSym=0;
   if (showSet1 == True)
      tf[0] = SymCountMq(ISymbols1);
   if (showSet2 == True)
      tf[1] = SymCountMq(ISymbols2);
   if (showSet3 == True)
      tf[2] = SymCountMq(ISymbols3);
   if (showSet4 == True)
      tf[3] = SymCountMq(ISymbols4);
   if (showSet5 == True)
      tf[4] = SymCountMq(ISymbols5);         
   
   for (i=0; i<5; i++)
      numSym += tf[i];   
   
   ArrayResize(ssym, numSym);
   ArrayResize(setOfSymbol, numSym);
   
   if (showSet1 == True)
      if (tf[0] != SymSettMq(ISymbols1, 0, 1))  
         Alert("Something go wrong when read symbols set 1");
   if (showSet2 == True)
      if (tf[1] != SymSettMq(ISymbols2, tf[0], 2))  
         Alert("Something go wrong when read symbols set 2");
   if (showSet3 == True)
      if (tf[2] != SymSettMq(ISymbols3, tf[1]+tf[0], 3))  
         Alert("Something go wrong when read symbols set 3");
   if (showSet4 == True)
      if (tf[3] != SymSettMq(ISymbols4, tf[2]+tf[1]+tf[0], 4))  
         Alert("Something go wrong when read symbols set 4");
   if (showSet5 == True)
      if (tf[4] != SymSettMq(ISymbols5, tf[3]+tf[2]+tf[1]+tf[0], 5))  
         Alert("Something go wrong when read symbols set 5");
   
   
   if (numSym <= 0) {
      Alert("All symols inputs are wrong");   
      return (-1);
   }
       
   ArrayResize(toPoint, numSym);
   
   for (i=0; i<numSym; i++) {
      m = MarketInfo(ssym[i], MODE_DIGITS);
      if (m<=0) {
         m=GetLastError();
         if(m==ERR_UNKNOWN_SYMBOL) Print("Canot find symbol: ",ErrorDescription(m));
         Alert("Please check currency symbol inputs!!  '", ssym[i],"'");
         continue;
      }   
      if (MarketInfo(ssym[0], MODE_DIGITS) == 3 || MarketInfo(ssym[0], MODE_DIGITS) == 5)
         toPoint[i]=MarketInfo(ssym[i], MODE_POINT) * 10;
      else
         toPoint[i]=MarketInfo(ssym[i], MODE_POINT);
   }
   

   if (numSym <= 0) {
      Alert("All symols inputs are wrong");   
      return (-1);
   }    
//   numSym -= n;
   ArrayResize(ssymShow, numSym);
   
   for (i=0; i<numSym; i++) {
      if (!StringFind(ssym[i], "GOLD", 0) || !StringFind(ssym[i], "SILVER", 0)) {
         ssymShow[i] = ssym[i];
         continue;
      }
      ssymShow[i] = StringSubstr(ssym[i], 0, 2);
      ssymShow[i] = StringConcatenate(ssymShow[i], "/", StringSubstr(ssym[i], 3, 2));
   }
   
   ArrayResize(current, numSym);
   ArrayResize(pcurrent, numSym);
   ArrayResize(dh, numSym);
   ArrayResize(dl, numSym);
   ArrayResize(dch, numSym);
   ArrayResize(dcl, numSym);
   ArrayResize(dco, numSym);
   ArrayResize(dcco, numSym);
   ArrayResize(dr, numSym);
         
   ArrayResize(dmco, numSym);
   ArrayResize(dHigh, numSym);
   ArrayResize(dLow, numSym);
   ArrayResize(dOpen, numSym);
   ArrayResize(adr, numSym);
   
   
//   ArrayResize(recaldata, numSym);
   ArrayResize(avalDataTf, numSym);
   ArrayInitialize(avalDataTf, False); 
   
   ind = WindowExpertName();
   IndicatorShortName(ind); 
   
   
   
   tfs[6] = Tperiod1;
   tfs[7] = Tperiod2;
   tfs[8] = Tperiod3;
   tfs[9] = Tperiod4;
   tfs[10] = Tperiod5;
   tfs[11] = Tperiod6;
   
   
   if (StringLen(tfs[6]) < 2) {
      Alert("Please check inserted time period.. Tperiod1..");
      return(0);
   }
   for (i=7; i<numTf; i++) {
      if (StringLen(tfs[i]) < 2) {
         Alert("Please check inserted time period.. Tperiod",i-5,"..");
//         numTf--;
      }
 /*     else if (StringLen(tfs[i-1]) < 2 && StringLen(tfs[i]) > 2)
            tfs[i-1] = tfs[i];   
*/   }   
   
   
   ArrayResize(tfFBar, numSym);
   ArrayResize(tfstart, numSym);
   ArrayResize(pBars, numSym);
   ArrayInitialize(pBars, 1);
   
   for (i=0; i<numFirstTf; i++) {
      if (tfc[i] == 0) {
         tf[i] = -1;
         tfs[i] = " ";
      }
      else {   
         tf[i]=PERIOD_D1; 
         tfs[i] = tfsc[i];
      }
      
      
      for (j=0; j<numSym;j++) {
         if (tfc[i] == 0) {
            tfstart[j][i] = -1;
            tfFBar[j][i]=-2;
         }   
         else {
            if (tfc[i] == 6) {
               tfstart[j][i] = StartBar(0,0,1,0, 0, 0);
               tfFBar[j][i] = iBarShift(ssym[j], tf[i], tfstart[j][i], False)-1;
            }   
            else if (tfc[i] == 7) {
               tfstart[j][i] = StartBar(0,1,0,0, 0, 0);
               tfFBar[j][i] = iBarShift(ssym[j], tf[i], tfstart[j][i], False)-1;
            }      
            else if (tfc[i] == 8) {
               tfstart[j][i] = StartBar(0,3,0,0, 0, 0);
               tfFBar[j][i] = iBarShift(ssym[j], tf[i], tfstart[j][i], False)-1;
            }      
            else if (tfc[i] == 9) {
               tfstart[j][i] = StartBar(1,0,0,0, 0, 0);
               tfFBar[j][i] = iBarShift(ssym[j], tf[i], tfstart[j][i], False)-1;
            }   
            else { 
               tfstart[j][i] = TimeCurrent() - (tfc[i]-1)*60;     
               tfFBar[j][i] = iBarShift(ssym[j], tf[i], tfstart[j][i], False);
            }
        }
         avalDataTf[j][i] = CheckForData(ssym[j], tf[i], tfFBar[j][i]+1);   
      }
   }
  
          
   
   
   for (i=6; i<numTf; i++) {
      tf[i]=PERIOD_D1;                   // make function!!!
      n = StringGetChar(tfs[i],0);
      if (n > 47 && n < 58) {
         for(j=0; j<numSym; j++) {
            tfstart[j][i] =  StrToTime(tfs[i]);
            tfFBar[j][i] = iBarShift(ssym[j], tf[i], tfstart[j][i], False); 
            checkForData = CheckForData(ssym[0], tf[i], tfFBar[j][i]+1);
            avalDataTf[j][i] = checkForData;
            if ( tfstart[j][i] - iTime(ssym[j], tf[i], tfFBar[j][i]+1) > 5*60*24*60+tf[i]*60) {
               checkForData = CheckForData(ssym[0], tf[i], tfFBar[j][i]+1);
               avalDataTf[j][i] = checkForData;
               if (checkForData == False) {
 //                 tfFBar[j][i] = iBars(ssym[j], tf[i])-1;
                  Alert ("Can not find data for: ",ssym[j],"  ", tfs[i],"First aval.", TimeToStr(iTime(ssym[j], tf[i], iBars(ssym[j], tf[i])-2),TIME_DATE));
               }
            }
            else {
               pBars[j][i] = iBars(ssym[j], tf[i]);
               avalDataTf[j][i] = True;
            } 
         }
      }
 /*     else if (n > 64 && n < 91) {
         switch (n) {
            case 'M': {
               if (StringGetChar(tfs[i],1) == 'N') {
                  tf[i] = ToInt(tfs[i], 2);
                  lDataBar = iBarShift(ssym[0], dataPeriod, StartBar(0, 0, 0, 1, statMode, timeAdj), False);
                  if (tf[i] < 1440
               }
               else
                  tf[i] = ToInt(tfs[i], 1);
            
            } break;
            
            //
            //Not in use yet
            //
            //
         }
     }
*/   }

     
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   for (i=0; i<=(numSym+1)*(6); i++)
      ObjectDelete(ind+(i)); 
   
   ObjectsDeleteAll(WindowFind(ind));     
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//   int    counted_bars=IndicatorCounted();
//----
   
      
    
   
         
//   recaldata[i] = False; 
   
   
   lDataBar = iBarShift(ssym[0], dataPeriod, StartBar(0, 0, 0, 1, statMode, timeAdj), False);
   
   if (showDailyStat == True || showMTStat == True || histoType == 1) {
      dchMax=0;
      dclMax=0;
      for (i=0; i<numSym; i++) {
         current[i] = iClose(ssym[i], tf[0], 0);
         if (current[i] == 0) {
            dh[i]=0;
            dl[i]=0;
            dch[i]=0;
            dcl[i]=0;
            dco[i]=0;
         }
         else if ((current[i] != pcurrent[i]) /* || iTime(ssym[i], dataPeriod,0)  != pTime[i]*/) { 
            //recaldata[i] = True;
            //Print("ldataBar: ", lDataBar);
            if (TimeCurrent() - iTime(ssym[i], dataPeriod, lDataBar) < dataPeriod*60) {
               dh[i] = iHigh(ssym[i], dataPeriod, 0);
               dl[i] = iLow(ssym[i], dataPeriod, 0);
            }
            else {   
               dh[i] = iHigh(ssym[i], dataPeriod, iHighest(ssym[i],dataPeriod,MODE_HIGH, lDataBar+1,0));
               dl[i] = iLow(ssym[i], dataPeriod, iLowest(ssym[i],dataPeriod,MODE_LOW, lDataBar+1,0));
            }
            dch[i] = (dh[i]-current[i])/toPoint[i];
            dcl[i] = (current[i]-dl[i])/toPoint[i];
            dr[i] = (dh[i]-dl[i])/toPoint[i];
                                       
            dcco[i] = (current[i]- iOpen(ssym[i],dataPeriod,lDataBar))/toPoint[i];
            if (changeInPips == True)
               dco[i] = (current[i]- iClose(ssym[i],dataPeriod,lDataBar+1))/toPoint[i];
            else
               dco[i] = (current[i]- iClose(ssym[i],dataPeriod,lDataBar+1))*100/iClose(ssym[i],dataPeriod,lDataBar+1);
            
            if (histoType == 1) {
               if (dch[i] > dchMax)
                  dchMax = dch[i];
               if (dcl[i] > dclMax)
                  dclMax = dcl[i];   
//               if (dr[i] > drMax)
//                  drMax = dr[i];    
            }
         }
      }
   }      
   else 
      for (i=0; i<numSym; i++) 
         current[i] = iClose(ssym[i], tf[0], 0);
   
//---- no needed      
   if (current[0] == pcurrent[0])
         return(0);  
   pcurrent[0] = current[0];
   
   


   for (i=0; i<numSym; i++) 
      for (j=0; j<numFirstTf; j++) 
         if (iBars(ssym[i], tf[j]) > pBars[i][j]) {
            switch (tfc[j]) {
               case 6: 
                  tfstart[i][j] = StartBar(0,0,1,0, 0, 0);
               break;
               case 7: 
                  tfstart[i][j] = StartBar(0,1,0,0, 0, 0);
               break;
               case 8:
                  tfstart[i][j] = StartBar(0,3,0,0, 0, 0);    
               break;
               case 9:
                  tfstart[i][j] = StartBar(1,0,0,0, 0, 0);
               break;
               default:
                  tfstart[i][j] = TimeCurrent() - (tfc[j]-1)*60;
               break;
            }   
            
          }  
              
      
   
   
   for (i=0; i<numSym; i++) {
      for (j=0; j<numTf; j++) {
         if (j >= numFirstTf && j<6)
            continue;
         if (iBars(ssym[i], tf[j]) > pBars[i][j]) {
            pBars[i][j] = iBars(ssym[i], tf[j]);
            tfFBar[i][j] = iBarShift(ssym[i], tf[j], tfstart[i][j], False);
            checkForData = CheckForData(ssym[i], tf[j], tfFBar[i][j]+1);
            avalDataTf[i][j] = checkForData;     
         }
      
      
      }
   }
   
    for (i=0; i<numSym; i++) {
      for (j=0; j<numFirstTf; j++) {
         dHigh[i][j] = (current[i]-iHigh(ssym[i], tf[j], iHighest(ssym[i],tf[j],MODE_HIGH, tfFBar[i][j]+1,0)))/toPoint[i];
         dLow[i][j] = (current[i]-iLow(ssym[i], tf[j], iLowest(ssym[i],tf[j],MODE_LOW, tfFBar[i][j]+1,0)))/toPoint[i];
         
      }
   }
   if (histoType == 1) {
      ArrayInitialize(adr, 0);
      for (i=0; i<numSym;i++) {
         for (j=0; j<=numFirstTf; j++) {
            count=0;
            for (k=1; k<tfFBar[i][j]+1; k++) {
               adr[i][j] += (iHigh(ssym[i], tf[j], k)-iLow(ssym[i], tf[j], k))/toPoint[i];
               count++;
            }      
            if (count == 0)
               adr[i][j] = (iHigh(ssym[i], tf[j], 0)-iLow(ssym[i], tf[j], 0))/toPoint[i];
            else
               adr[i][j] /= count;
         }
      }
   }
   
   n=0;
   if (showDailyStat == True) {
      n=6;
      xx0=190;

         WriteL(ind+0, sideDS, xx+165, yy, StringConcatenate("From: ",TimeToStr(iTime(NULL, dataPeriod, lDataBar+1)+60*dataPeriod,TIME_DATE|TIME_MINUTES)), fontSize-3, scaleText,fontName ,textCol,whereDS);   
         WriteL(ind+1, sideDS, xx+140, yy," Bid     ", fontSize-3, scaleText, fontName ,textCol,whereDS);
         WriteL(ind+2, sideDS, xx+105, yy," Daily range ", fontSize-3, scaleText, fontName ,textCol,whereDS); 
         WriteL(ind+3, sideDS, xx+70, yy," From high ", fontSize-3, scaleText, fontName ,textCol,whereDS);
         WriteL(ind+4, sideDS, xx+40, yy," From low ", fontSize-3, scaleText, fontName ,textCol,whereDS);
         WriteL(ind+5, sideDS, xx, yy," Change ", fontSize-3, scaleText, fontName ,textCol,whereDS);
      
      for (i=0; i<numSym; i++) {
            color cCol = SetCol(dco[i]);
            WriteL(ind+(i+n), sideDS, xx+190, yy+10*(i+1), ssymShow[i], fontSize,  scaleText, fontName ,SymbolSetColor(setOfSymbol[i]),whereDS); 
            WriteL(ind+(i+n+1*numSym), sideDS, xx+140, yy+10*(i+1), DoubleToStr(current[i], MarketInfo(ssym[i], MODE_DIGITS)), fontSize, scaleText, fontName ,cCol,whereDS); 
            WriteL(ind+(i+n+2*numSym), sideDS, xx+105, yy+10*(i+1), DoubleToStr(dr[i], 0), fontSize, scaleText, fontName ,cCol,whereDS);
            WriteL(ind+(i+n+3*numSym), sideDS, xx+70, yy+10*(i+1), DoubleToStr(dch[i], 0), fontSize, scaleText, fontName ,cCol,whereDS); 
            WriteL(ind+(i+n+4*numSym), sideDS, xx+40, yy+10*(i+1), DoubleToStr(dcl[i], 0), fontSize, scaleText, fontName ,cCol,whereDS); 
            if (changeInPips == True)
               WriteL(ind+(i+n+5*numSym), sideDS, xx, yy+10*(i+1), DoubleToStr(dco[i], 0), fontSize, scaleText ,fontName ,cCol,whereDS); 
            else
               WriteL(ind+(i+n+5*numSym), sideDS, xx, yy+10*(i+1), StringConcatenate(DoubleToStr(dco[i], 2),"%"), fontSize, scaleText, fontName ,cCol,whereDS);
      }
   } 
      
 
   if (showMTStat == True) {
      numPrObj = n*(numSym+1);
      n++;
      xx0=xx;
      
      for (i=0; i<numSym; i++) 
         WriteL(ind+(i+numPrObj), 1, xx+i*35, yy, ssymShow[i], fontSize-1, scaleText, fontName , SymbolSetColor(setOfSymbol[i]),WindowFind(ind));
   
      numPrObj = n*(numSym+1);
      xx0 += numSym*35;
      
      if (showSmallTfText ==True) {
         firstTf=0;
         for (i=firstTf; i<numFirstTf; i++) 
            WriteL(ind+(i+numPrObj), 1, xx0, yy+10*(i-firstTf+1), StringConcatenate(tfs[i]," (",TimeToStr(iTime(ssym[0], tf[i],tfFBar[0][i]+1)+tf[i]*60-1, TIME_DATE|TIME_MINUTES), ")"), fontSize-2, scaleText, fontName ,textCol,WindowFind(ind));
      }
      else
         firstTf=6;
      
      for (i=6; i<numTf; i++) 
         WriteL(ind+(i+numPrObj), 1, xx0, yy+10*(i-firstTf+1), tfs[i], fontSize-2, scaleText, fontName ,textCol,WindowFind(ind));
       
      numPrObj += (numTf-firstTf);
      for (i=0; i<numSym; i++) {
            for (j=0; j<numTf; j++) {
               if (j >= numFirstTf && j<6)
                  continue;
               
               if (avalDataTf[i][j]==true)
                  dmco[i][j]= (current[i]- iClose(ssym[i],tf[j],tfFBar[i][j]+1))/toPoint[i];     
               else {
                  checkForData = CheckForData(ssym[i], tf[j], tfFBar[i][j]+1);
                  avalDataTf[i][j]=checkForData;     
                  dmco[i][j]=0;
               }               
            }
        
      }     
      for (i=0; i<numSym; i++) {
         for (j=firstTf; j<numTf; j++) {
            if (j >= numFirstTf && j<6)
                  continue;
            if (avalDataTf[i][j] == True)
               WriteL(ind+(i+(j)*numSym+numPrObj), 1, xx+i*35, yy+10*(j-firstTf+1),  DoubleToStr(dmco[i][j], 0), fontSize,  scaleText, fontName ,SetCol(dmco[i][j]),WindowFind(ind));     
         }
      }
   }
   
   else if (showSmallTfText ==True) {
      numPrObj = n*(numSym+1);
      n++;
      xx0=xx;
      
      for (i=0; i<numSym; i++) 
         WriteL(ind+(i+numPrObj), 1, xx+i*35, yy, ssymShow[i], fontSize-1, scaleText, fontName , SymbolSetColor(setOfSymbol[i]),WindowFind(ind));
      
      xx0 += numSym*35;
      numPrObj = n*(numSym+1);
      firstTf=0;
      for (i=firstTf; i<numFirstTf; i++) 
         WriteL(ind+(i+numPrObj), 1, xx0, yy+10*(i-firstTf+1), StringConcatenate(tfs[i]," (",TimeToStr(iTime(ssym[0], tf[i],tfFBar[0][i]+1)+tf[i]*60-1, TIME_DATE|TIME_MINUTES), ")"), fontSize-2,  scaleText, fontName ,textCol,WindowFind(ind));
      
      for (i=0; i<numSym; i++) {
         for (j=0; j<numFirstTf; j++) {
            if (avalDataTf[i][j]==true)
               dmco[i][j]= (current[i]- iClose(ssym[i],tf[j],tfFBar[i][j]+1))/toPoint[i];
            else {
               checkForData = CheckForData(ssym[i], tf[j], tfFBar[i][j]+1);
               avalDataTf[i][j]=checkForData;     
               dmco[i][j]=0;               
            }         
         }
      }
       numPrObj += (numFirstTf);
      for (i=0; i<numSym; i++) {
         for (j=0; j<numFirstTf; j++) {
            if (avalDataTf[i][j] == True)
               WriteL(ind+(i+(j)*numSym+numPrObj), 1, xx+i*35, yy+10*(j-firstTf+1),  DoubleToStr(dmco[i][j], 0), fontSize,  scaleText, fontName ,SetCol(dmco[i][j]),WindowFind(ind));     
         }
      }
   }   

   
   else {
      for (i=0; i<numSym; i++) {
         for (j=0; j<numFirstTf; j++) {
            if (avalDataTf[i][j]==true)
               dmco[i][j]= (current[i]- iClose(ssym[i],tf[j],tfFBar[i][j]+1))/toPoint[i];
            else {
               checkForData = CheckForData(ssym[i], tf[j], tfFBar[i][j]+1);
               avalDataTf[i][j]=checkForData;     
               dmco[i][j]=0;               
            }         
         }
      }
   }
      
   
   
//   int ce = WindowBarsPerChart();
   int ce = (1-barsSpace)*WindowBarsPerChart();
      
   if(ce > WindowFirstVisibleBar())
      ce= WindowFirstVisibleBar();
   
   if (WindowBarsPerChart()>WindowFirstVisibleBar())
int      limitBar = WindowFirstVisibleBar()-WindowBarsPerChart()*(1-barsSpace);
     limitBar = MathMax(limitBar, 0);    
//   else
//      ce =  (1-barsSpace)*WindowBarsPerChart();        
//      barsSpace = ce -  WindowFirstVisibleBar();
//   ce -= (barsSpace);
   
   
   
   if (histoType == 0) {
      ArrayInitialize(mr, EMPTY_VALUE);   
      ArrayInitialize(hi, EMPTY_VALUE);
      ArrayInitialize(lo, EMPTY_VALUE);
      
      multb=MathFloor(ce/(numSym*numFirstTf + numSym-1));
      space = MathFloor((ce - multb*numSym*(numFirstTf))/(numSym-1));
      
      if (multb < 2)
         multb = 2;
   
      lastBar = WindowFirstVisibleBar()-numSym*(multb*(numFirstTf) + (space-1));  
      if (lastBar < limitBar)
         lastBar = limitBar;
   
      for (i=0; i<numSym; i++)
         for (j=0; j<numFirstTf; j+=1) {
            for(k=0; k<multb/2; k+=1) {
               mr[lastBar + k + multb*j + i*(space+multb*numFirstTf)] = dmco[i][numTf-(6-numFirstTf+7)-j];
               hi[lastBar + k + multb*j + i*(space+multb*numFirstTf)] = dHigh[i][numTf-(6-numFirstTf+7)-j];
               lo[lastBar + k + multb*j + i*(space+multb*numFirstTf)] = dLow[i][numTf-(6-numFirstTf+7)-j];
            }
            for(k=multb/2; k<multb; k+=1) {
               mr[lastBar + k + multb*j + i*(space+multb*numFirstTf)] = EMPTY_VALUE;
               hi[lastBar + k + multb*j + i*(space+multb*numFirstTf)] = dHigh[i][numTf-(6-numFirstTf+7)-j];
               lo[lastBar + k + multb*j + i*(space+multb*numFirstTf)] = dLow[i][numTf-(6-numFirstTf+7)-j];
            }
         
         }
         symTextSp1 = multb*(numFirstTf/2);
         symTextSp2 = space+multb*numFirstTf; 
   }
   else if (showHistogram == True) {
      hiMax=0;
      
      ArrayInitialize(mr, EMPTY_VALUE);   
      ArrayInitialize(hi, EMPTY_VALUE);
      ArrayInitialize(lo, EMPTY_VALUE);
      ArrayInitialize(mr1, EMPTY_VALUE);
      
      multb=MathFloor((ce-numSym)/(numSym*numFirstTf + numSym-1));
      space = MathFloor((ce - numSym*(1+multb*numFirstTf))/(numSym-1));
      
      if (multb < 3)
         multb = 3;
   
      lastBar = WindowFirstVisibleBar()-numSym*(multb*numFirstTf + (space-1)+1);  
      if (lastBar < limitBar)
         lastBar = limitBar;
      
   
      for (i=0; i<numSym; i++) {
         for (j=0; j<numFirstTf; j+=1) {
            for(k=0; k<multb/3; k+=1) {
               if (dmco[i][numTf-(6-numFirstTf+7)-j] >= 0) {
                  mr[lastBar + k + multb*j + i*(space+multb*numFirstTf)] = dmco[i][numTf-(6-numFirstTf+7)-j];
                  mr1[lastBar + k + multb*j + i*(space+multb*numFirstTf)] = EMPTY_VALUE;
               }
               else {
                  mr[lastBar + k + multb*j + i*(space+multb*numFirstTf)] = EMPTY_VALUE;
                  mr1[lastBar + k + multb*j + i*(space+multb*numFirstTf)] = MathAbs(dmco[i][numTf-(6-numFirstTf+7)-j]);  
               }     
               hi[lastBar + k + multb*j + i*(space+multb*numFirstTf)] = EMPTY_VALUE;
               lo[lastBar + k + multb*j + i*(space+multb*numFirstTf)] = EMPTY_VALUE;
            }
            for(k=multb/3; k<2*multb/3; k+=1) {
               mr[lastBar + k + multb*j + i*(space+multb*numFirstTf)] = EMPTY_VALUE;
               hi[lastBar + k + multb*j + i*(space+multb*numFirstTf)] = EMPTY_VALUE;
               lo[lastBar + k + multb*j + i*(space+multb*numFirstTf)] = adr[i][numFirstTf-1-j];
            }  
            for(k=2*multb/3; k<multb; k+=1) {
               mr[lastBar + k + multb*j + i*(space+multb*numFirstTf)] = EMPTY_VALUE;
               hi[lastBar + k + multb*j + i*(space+multb*numFirstTf)] = MathAbs(dHigh[i][numTf-(6-numFirstTf+7)-j]) + dLow[i][numTf-(6-numFirstTf+7)-j];
               lo[lastBar + k + multb*j + i*(space+multb*numFirstTf)] = EMPTY_VALUE;
            }
            
         }
         if (hi[lastBar + 0 + multb*j + i*(space+multb*numFirstTf)] > hiMax)
            hiMax = hi[lastBar + multb-1 + multb*0 + i*(space+multb*numFirstTf)];
         
      }
      
      if (showDailyBar == True) {
         WindowRedraw();
         hiMax = WindowPriceMax(WindowFind(ind));
         scaleDaBar = hiMax/(dchMax+dclMax);
         scaleDaBar *= 0.7;
         zeroLevelDaBar = 0.95*hiMax-dchMax*scaleDaBar;
      
//      ObjectCreate("0Level", OBJ_HLINE, WindowFind(ind), TimeCurrent(), zeroLevelDaBar);
         DrawLLine(WindowFind(ind)+" Daily Bar Level 0", Time[lastBar+multb*(numFirstTf-1)], zeroLevelDaBar ,Time[lastBar+multb*(numFirstTf)], "Zero level - Daily bar", "0", Gray, 1, STYLE_DASHDOTDOT, WindowFind(ind));
         tmp = MathMin(dchMax,dclMax);
         tmp = NormalizeDouble(tmp/20,0)*10;
         if (tmp < 10)
            tmp = 5;
         DrawLLine(WindowFind(ind)+" Daily Bar Level -", Time[lastBar+multb*(numFirstTf-1)], zeroLevelDaBar-tmp*scaleDaBar ,Time[lastBar+multb*(numFirstTf)], 
            StringConcatenate(DoubleToStr(tmp*(-1),0), " - Daily bar"), DoubleToStr(tmp*(-1),0), Gray, 1, STYLE_DASHDOT , WindowFind(ind));
         DrawLLine(WindowFind(ind)+" Daily Bar Level +", Time[lastBar+multb*(numFirstTf-1)], zeroLevelDaBar+tmp*scaleDaBar ,Time[lastBar+multb*(numFirstTf)], 
            StringConcatenate(DoubleToStr(tmp,0), " - Daily bar"), DoubleToStr(tmp,0), Gray, 1, STYLE_DASHDOT , WindowFind(ind)); 
      
         for (i=0; i<numSym; i++) {
            DrawBLine(WindowFind(ind)+" Bar"+ssym[i]+"RangeHiLo", Time[lastBar + multb + multb*(numFirstTf-1) + i*(space+multb*numFirstTf)], zeroLevelDaBar+dch[i]*scaleDaBar, zeroLevelDaBar-dcl[i]*scaleDaBar, 
               StringConcatenate("Range: ", dr[i], "\nFrom Hi- From Lo: ", DoubleToStr(dch[i],0), " - ", DoubleToStr(dcl[i],0)), Green, 1, WindowFind(ind));
         
            if (changeInPips == True)
               tmptext = DoubleToStr(dco[i],0);
            else
               tmptext = StringConcatenate(DoubleToStr(dco[i],3),"%");
         
            DrawBLine(WindowFind(ind)+" Bar"+ssym[i]+"Change", Time[lastBar + multb + multb*(numFirstTf-1) + i*(space+multb*numFirstTf)], zeroLevelDaBar, zeroLevelDaBar-dcco[i]*scaleDaBar, 
               StringConcatenate("Current price: ", current[i], "\nOp-Cl: ", dcco[i], "\nChange: ", tmptext), SetCol(dcco[i]), 3, WindowFind(ind));
         }
      }
      symTextSp1 = multb*(numFirstTf/2);
      symTextSp2 = space+multb*numFirstTf;
   } 
    
   else if (showDailyBar == True) {
   
      ArrayInitialize(mr1, EMPTY_VALUE);
      ArrayInitialize(mr, EMPTY_VALUE);   
      ArrayInitialize(hi, EMPTY_VALUE);
      ArrayInitialize(lo, EMPTY_VALUE);
      
      multb=MathFloor((ce)/(numSym  + numSym-1));
      space = MathFloor((ce - numSym*multb)/(numSym-1));
      if (multb < 3)
         multb = 3;  
      lastBar = WindowFirstVisibleBar()-numSym*(multb*numFirstTf + (space-1)+1);  
      if (lastBar < limitBar)
         lastBar = limitBar;
      
      for (i=0; i<numSym; i++) {
         for (j=0; j<multb/3; j++) {
            if (dcco[i] >= 0) { 
               mr[lastBar + j + i*(multb+space)] = (-1)*dcco[i];
               mr[lastBar + j + i*(multb+space)+2*multb/3] = (-1)*dcco[i];
            }
            else {
               mr1[lastBar + j + i*(multb+space)] = (-1)*dcco[i];
               mr1[lastBar + j + i*(multb+space)+2*multb/3] = (-1)*dcco[i];
            }
         }
         for (j=multb/3; j< 2*multb/3; j++) {  
            hi[lastBar + j + i*(multb+space)] = dch[i];
            lo[lastBar + j + i*(multb+space)] = (-1)*dcl[i];   
         }     
      }
      symTextSp1 = 0;
      symTextSp2 = multb+space;
   }
   for (i=0; i<numSym; i++)
      WriteT(ind+(ssymShow[i]+i), 1, Time[lastBar + 0 + symTextSp1 + i*symTextSp2], WindowPriceMin(WindowFind(ind))+(0.25+0.075*MathMod(i,2))*(WindowPriceMax(WindowFind(ind))-WindowPriceMin(WindowFind(ind))) , ssymShow[i], symbolFontSize,fontName ,SymbolSetColor(setOfSymbol[i]),WindowFind(ind));                        
 //     WriteT(ind+(ssymShow[i]+i), 1, Time[lastBar + 0 + multb*(numFirstTf/2) + i*(space+multb*numFirstTf)], WindowPriceMin(WindowFind(ind))+(0.25+0.05*MathMod(i,2))*(WindowPriceMax(WindowFind(ind))-WindowPriceMin(WindowFind(ind))) , ssymShow[i], symbolFontSize,fontName ,SymbolSetColor(setOfSymbol[i]),WindowFind(ind));  
   WindowRedraw();        
 
//----
   return(0);
  }

//+------------------------------------------------------------------+

void DrawLLine(string LBL, datetime X1, double Y1,  datetime X2, string text, string text1,  color col, int width, int style, int where)
{
   ObjectCreate(LBL, OBJ_TREND, where, 0, 0, 0, 0);
   ObjectSet(LBL,OBJPROP_TIME1,X1);
   ObjectSet(LBL,OBJPROP_TIME2,X2);
   ObjectSet(LBL,OBJPROP_PRICE1,Y1);
   ObjectSet(LBL,OBJPROP_PRICE2,Y1);
   ObjectSet(LBL, OBJPROP_COLOR, col);
   ObjectSet(LBL, OBJPROP_WIDTH, width);
   ObjectSet(LBL, OBJPROP_STYLE, style);
   ObjectSet(LBL, OBJPROP_RAY, True);
   ObjectSetText(LBL, text);
   ObjectCreate(LBL+"mark", OBJ_TEXT, where,X1,Y1); 
   ObjectSetText(LBL+"mark",text1, 8, fontName, col);
}

void DrawBLine(string LBL, datetime X1, double Y1,  double Y2, string text, color col, int width, int where)
{
   ObjectCreate(LBL, OBJ_TREND, where, 0, 0, 0, 0);
   ObjectSet(LBL,OBJPROP_TIME1,X1);
   ObjectSet(LBL,OBJPROP_TIME2,X1);
   ObjectSet(LBL,OBJPROP_PRICE1,Y1);
   ObjectSet(LBL,OBJPROP_PRICE2,Y2);
   ObjectSet(LBL, OBJPROP_COLOR, col);
   ObjectSet(LBL, OBJPROP_WIDTH, width);
   ObjectSet(LBL, OBJPROP_RAY, False);
   ObjectSetText(LBL, text); 
}


void WriteL(string LBL, double side, int X, int Y, string text, int fontsize, double scale, string fontname, color lcolor, int where)
{

//   if (ObjectFind(LBL) < 0) {
      ObjectCreate(LBL, OBJ_LABEL, where, 0 , 0);
      ObjectSet(LBL, OBJPROP_CORNER, side); 
      ObjectSet(LBL, OBJPROP_XDISTANCE, X*scale);
      ObjectSet(LBL, OBJPROP_YDISTANCE, Y*scale);
      
//   }
   ObjectSetText(LBL,text, fontsize*scale, fontname, lcolor);
 
}

void WriteT(string LBL, double side, datetime X, double Y, string text, int fontsize, string fontname, color lcolor, int where)
{

   if (ObjectFind(LBL) < 0) {
      ObjectCreate(LBL, OBJ_TEXT, where, X , Y);
      ObjectSetText(LBL,text, fontsize, fontname, lcolor);
   }
   else {
      ObjectMove(LBL, 0, X, Y); 
   }

 
}


//+------------------------------------------------------------------+
/*
void TBar(string LBL, int X,  double h, int X1, color Tcol)
{

   ObjectCreate(LBL, OBJ_RECTANGLE, WindowFind(ind), 0 , 0);
   ObjectSet(LBL, OBJPROP_COLOR, Tcol);
   ObjectCreate(LBL+"1", OBJ_TEXT, WindowFind(ind), (X+X1)/2 , 0.9*h);
   ObjectSet(LBL+"1", OBJPROP_CORNER, 0);
   ObjectSetText(LBL+"1",text, fontsize, fontname, T1color);
//   ObjectSet(LBL+"1", OBJPROP_ANGLE, 90);
 
 
} 
*/ 

//+------------------------------------------------------------------+






datetime StartBar(int dye, int dmo, int dwe, int dda, int typ, int ot)
{
   int ye,mo,da,ho;   
   int dayinSec=60*60*24;
   datetime ct;
     
      
   ct=TimeCurrent();
   switch (typ) {
      case 0: {
         if (dda > 0)
            ct -= 60*60*(24)*(dda-1);
         if (dwe > 0)
            ct -= 60*60*24*(7)*(dwe-1);
         
         ye = TimeYear(ct);
         mo = TimeMonth(ct);
         da = TimeDay(ct);
         ho = TimeHour(ct);

         if (dda > 0)
            ho=0;
         if (dwe > 0) {
            ho=0;
            if (TimeDayOfWeek(TimeCurrent()) < TimeDay(TimeCurrent()))
               da -= (TimeDayOfWeek(TimeCurrent())-1);
            else {
               ct = StrToTime(ye+"."+mo+"."+da+" "+ho);
               ct-=dayinSec*(TimeDayOfWeek(ct)-1);
               ye = TimeYear(ct);
               mo = TimeMonth(ct);
               da = TimeDay(ct);
               ho = TimeHour(ct);
            }   
         }
         if (dmo > 0) {
           da=1;
           ho=0;
           mo -= (dmo-1);
           while (mo < 0) {
               mo +=12;
               ye -= 1;
           }
           ct = StrToTime(ye+"."+mo+"."+da+" "+ho); 
           
           if (TimeDayOfWeek(ct) > 5)
               ct+= (2*dayinSec);
           else if (TimeDayOfWeek(ct) < 1)
               ct+=dayinSec;
           else if (TimeDayOfWeek(ct) > 1)
               ct-=dayinSec*(TimeDayOfWeek(ct)-1);
            ye = TimeYear(ct);
            mo = TimeMonth(ct);
            da = TimeDay(ct);
            ho = TimeHour(ct);        
         }
         if (dye > 0) {
           da=1;
           mo=1;
           // da  -= DayOfYear()+1 ;
           ho=0;
           ye -= (dye-1);
           ct = StrToTime(ye+"."+mo+"."+da+" "+ho); 
           
           if (TimeDayOfWeek(ct) > 5)
               ct+= (2*dayinSec);
           else if (TimeDayOfWeek(ct) < 1)
               ct+=dayinSec;
           else if (TimeDayOfWeek(ct) > 1)
               ct-=dayinSec*(TimeDayOfWeek(ct)-1);
            ye = TimeYear(ct);
            mo = TimeMonth(ct);
            da = TimeDay(ct);
            ho = TimeHour(ct);   
         
         
         }
       if (ot != 0) {
           ct = StrToTime(da+"."+mo+"."+ye+" "+ho);
           if (ot > TimeHour(TimeCurrent()))
               ct = ct + (ot-24)*3600;     
           else 
             ct += (ot)*3600;    
           //cd -=  (ot)*3600
           ye = TimeYear(ct);
           mo = TimeMonth(ct);
           da = TimeDay(ct);
           ho = TimeHour(ct);
        }
        
      } break;
      
      case 1: {      
         ct = TimeCurrent()+3600;
         if (dda > 0) 
            ct -= 60*60*(24)*dda;
         if (dwe > 0)
            ct -= 60*60*24*(7)*dwe;   
      
         ye = TimeYear(ct);
         mo = TimeMonth(ct);
         da = TimeDay(ct);
         ho = TimeHour(ct);
      
         if (dmo > 0) {
            mo -= dmo;
            while (mo < 0) {
               mo +=12;
               ye -= 1;
            }
         }
         if (dye > 0) {
            ye -= dye;
         }
     } break;
     
     default: {
         ye = Year();
          mo = Month();
          da = Day();
         ho = Hour();   
     } break;
  }   
 // return (StrToTime(StringConcatenate(/*"D'",*/da,".",mo,".",ye," ",ho/*,"'"*/)));

 // return (StrToTime(da+"."+mo+"."+ye+" "+ho));   
 // 
   return (StrToTime(ye+"."+mo+"."+da+" "+ho)); 
} 

//+------------------------------------------------------------------+

color SetCol(double param)
{
   if (param > 0)
      return(uCol);
   else if (param < 0)
      return(dCol);
   else
      return(nCol);
}
      

color SymbolSetColor(int set)
{
   color col;
   
   switch (set) {
      case 1:
         col=setColor1;
      break;
      case 2:
         col=setColor2;
      break;
     case 3:
         col=setColor3;
      break; 
     case 4:
         col=setColor4;
     break; 
     case 5:
         col=setColor5;
     break;
   }
   return (col);
} 
      
            
//+------------------------------------------------------------------+

bool CheckForData(string sym, int per, int n)
{
   
   if (iOpen(sym,per,n) == 0) {
      for (int j=0; j<2; j++) {
         if (iOpen(sym,per,n) > 0) 
            return (True);
         Sleep(500);   
      }               
      if (iOpen(sym, per, n) > 0) 
          return (True);
      else {
        // Alert("Please check currency symbol inputs. No spaces, ...just symbols and ',' \n If your inputs are OK, maybe need some time to update data!!  ", ssym[i]);
         return (False);
      }
   }
   return (True);
}

//+------------------------------------------------------------------+ 

int SymCountMq(string symbols)
{
   int i=0;
   int count=1;
   
   if (StringLen(symbols) == 0)
      return (0);
      
   while ( i >= 0) {
      i = StringFind(symbols, ",", i);
      if (i==0) {
         Alert("Please check your inpus symbols");
         count = 0;
         break;
      }
      if (i < 0)
         break;
      if (i==  StringLen(symbols)-1)
         break;
      
      i++;   
      count++;   
   }
   return(count);        
}
//+------------------------------------------------------------------+

int SymSettMq(string symbols ,int firstIndex, int set)
{
   
   int i = 0;
   int ne = 0;
   int ns = 0;
   
   while (ne < StringLen(symbols)) {
      ne = StringFind(symbols, ",", ns);
      if (ne < 0)
         ne = StringLen(symbols);   
      ssym[firstIndex+i]=StringSubstr(symbols, ns, ne-ns);
      ns = ne+1;
      ssym[firstIndex+i] = StringTrimLeft(ssym[firstIndex+i]);
      ssym[firstIndex+i] = StringTrimRight(ssym[firstIndex+i]);
      setOfSymbol[firstIndex+i] = set;
      i++;
   }
   return (i);
}

/*
int ToInt(string convert, int start)
{
   string conv;
   
   conv = StringSubstr(convert, start, StringLen(convert)-start);
   return(StrToInteger(conv));
}
*/   
    